var MarkdownEditController = JSB.defineClass('MarkdownEditController : UIViewController', {
  viewDidLoad: function() {
    var webFrame = self.view.bounds;

    self.webView = new UIWebView(webFrame);
    
    self.webView.scalesPageToFit = true;
    self.webView.autoresizingMask = (1 << 1 | 1 << 4);
    self.webView.delegate = self;
    self.webView.scrollView.delegate = self;
    self.webView.scrollView.scrollEnabled = false; 
	self.webView.scrollView.bounces = false;
    self.view.addSubview(self.webView);
    
    self.tempPath = Application.sharedInstance().tempPath + NSUUID.UUID().UUIDString();
    NSFileManager.defaultManager().createDirectoryAtPathWithIntermediateDirectoriesAttributes(self.tempPath,true,{});
    
    NSFileManager.defaultManager().copyItemAtPathToPath(self.mainPath + '/editormd',self.tempPath + '/editormd');
  },
  viewWillAppear: function(animated) {
    self.loaded = false;
    self.webView.delegate = self;
    self.view.backgroundColor = Application.sharedInstance().defaultNotebookColor;
    self.webView.backgroundColor = Application.sharedInstance().defaultNotebookColor;
    self.webView.loadFileURLAllowingReadAccessToURL(NSURL.fileURLWithPath(self.tempPath + '/editormd/edit.html'),NSURL.fileURLWithPath(Application.sharedInstance().tempPath));
    //self.webView.loadRequest(NSURLRequest.requestWithURL(NSURL.fileURLWithPath(self.mainPath + '/editormd/edit.html')));
  },
  viewWillDisappear: function(animated) {
    if(!self.loaded){
      self.retfunc({html:self.html,text:self.text,dirty:false});        
      return;
    }
    self.webView.evaluateJavaScript("document.getElementsByClassName('button-bar__button--editor-toggler')[0].click();document.querySelectorAll('svg[id^=\"mermaid-svg-\"]').forEach(function(element){element.style.height ='100%';});document.body.style.width = '400px';var event = document.createEvent('HTMLEvents');event.initEvent('resize', true, true);window.dispatchEvent(event);window.editorSvc.previewCtx.html",function(html){
        self.webView.evaluateJavaScript("window.editorSvc.clEditor.getContent();",function(text){
            self.webView.evaluateJavaScript("var mynode = document.getElementsByClassName('preview__inner-2')[0];var rect = mynode.getBoundingClientRect();var totalheight=0;var nodes = mynode.children;for(var i=0; i<nodes.length; i++) {totalheight=totalheight+nodes[i].clientHeight;}var size = {width:rect.width,height:Math.max(totalheight+20,50)};size;",function(e){
              var size = JSON.parse(e);
              self.retfunc({text:text,html:html,dirty:(self.text != text),size:size});      
            });
        });
    });
    self.webView.delegate = null;
  },
  viewDidLayoutSubviews: function() {
    self.webView.evaluateJavaScript("document.body.style.height = '"+self.view.bounds.height+"px';var event = document.createEvent('HTMLEvents');event.initEvent('resize', true, true);window.dispatchEvent(event);window.scrollTo(0, 0);");
  },
  viewWillLayoutSubviews: function() {
    if(self.loaded){
    }
  },
  scrollViewDidScroll: function() {
  },
  webViewDidStartLoad: function(webView) {
  },
  webViewDidFinishLoad: function(webView) {
    
	
    NSTimer.scheduledTimerWithTimeInterval(0.2,true,function(timer){
	  self.webView.evaluateJavaScript("document.getElementsByClassName('layout');",function(element){
		  if(typeof(element) != 'undefined' && element != null){
        var scp = "window.editorSvc.clEditor.setContent('"+self.text.replace(/\\/g,"\\\\").replace(/'/g,"\\'").replace(/\n/g,"\\n")+"',null,null);";
		self.webView.evaluateJavaScript(scp);
		timer.invalidate();
		self.loaded = true;
		}
	  });
	 });
  },
  webViewDidFailLoadWithError: function(webView, error) {
  },
});


